Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util.filter
Class LikeFilter

`java.lang.Object
com.tangosol.util.Base
com.tangosol.util.BitHelper
com.tangosol.util.ExternalizableHelper
com.tangosol.util.filter.ExtractorFilter
com.tangosol.util.filter.ComparisonFilter
com.tangosol.util.filter.LikeFilter`

All Implemented Interfaces:
  ExternalizableLite, PortableObject, Filter, EntryFilter, IndexAwareFilter, Serializable

      public class LikeFilter

extends ComparisonFilter
implements IndexAwareFilter

Filter which compares the result of a method invocation with a value for pattern match. A pattern can include regular characters and wildcard characters '_' and '%'. <p/> During pattern matching, regular characters must exactly match the characters in an evaluated string. Wildcard character '_' (underscore) can be matched with any single character, and wildcard character '%' can be matched with any string fragment of zero or more characters.

Author:
  cp/gg 2002.10.27

Field Summary

Fields inherited from class com.tangosol.util.filter.ComparisonFilter
`m_oValue`

Fields inherited from class com.tangosol.util.filter.ExtractorFilter
`EVAL_COST, m_extractor`

Constructor Summary
`LikeFilter()` Default constructor (necessary for the ExternalizableLite interface).
`LikeFilter(String sMethod, String sPattern)` Construct a LikeFilter for pattern match.
`LikeFilter(String sMethod, String sPattern, boolean fIgnoreCase)` Construct a LikeFilter for pattern match.
`LikeFilter(String sMethod, String sPattern, char chEscape, boolean fIgnoreCase)` Construct a LikeFilter for pattern match.
`LikeFilter(ValueExtractor extractor, String sPattern, char chEscape, boolean fIgnoreCase)` Construct a LikeFilter for pattern match.

Method Summary
`Filter` | `applyIndex(Map mapIndexes, Set setKeys)` Filter remaining keys using a Map of available indexes.
`protected void` | `buildPlan()` Build a plan for processing the LIKE functionality.
`int` | `calculateEffectiveness(Map mapIndexes, Set setKeys)` Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be.
`protected boolean` | `evaluateExtracted(Object oExtracted)` Evaluate the specified extracted value.
`char` | `getEscapeChar()` Obtain the escape character that is used for escaping '%' and '_' in the pattern or zero if there is no escape.
`String` | `getPattern()` Obtain the filter's pattern string.
`boolean` | `isIgnoreCase()` Check whether or not the filter is case incensitive.
`protected boolean` | `isMatch(String sValue)` Check the passed String value to see if it matches the pattern that this filter was constructed with.
`void` | `readExternal(DataInput in)` Restore the contents of this object by loading the object's state from the passed DataInput object.
`void` | `readExternal(PofReader in)` Restore the contents of a user type instance by reading its state using the specified PofReader object.
`void` | `showPlan()` Display the execution plan that the LikeFilter has selected.
`void` | `writeExternal(DataOutput out)` Save the contents of this object by storing the object's state into the passed DataOutput object.
`void` | `writeExternal(PofWriter out)` Save the contents of a POF user type instance by writing its state using the specified PofWriter object.

Methods inherited from class com.tangosol.util.filter.ComparisonFilter
`calculateIteratorEffectiveness, calculateMatchEffectiveness, calculateRangeEffectiveness, equals, getValue, hashCode, toString`

Methods inherited from class com.tangosol.util.filter.ExtractorFilter
`evaluate, evaluateEntry, extract, getValueExtractor`

Methods inherited from class com.tangosol.util.BitHelper
`countBits, countBits, countBits, indexOfLSB, indexOfLSB, indexOfLSB, indexOfMSB, indexOfMSB, indexOfMSB, rotateLeft, rotateLeft, rotateLeft, rotateRight, rotateRight, rotateRight, toBitString, toBitString, toBitString`

Methods inherited from interface com.tangosol.util.filter.EntryFilter
`evaluateEntry`

Methods inherited from interface com.tangosol.util.Filter
`evaluate`

Constructor Detail

### LikeFilter

    public LikeFilter()

  Default constructor (necessary for the ExternalizableLite interface).

### LikeFilter

    public LikeFilter(String sMethod,
                      String sPattern)

  Construct a LikeFilter for pattern match.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `sPattern` - the string pattern to compare the result with

### LikeFilter

    public LikeFilter(String sMethod,
                      String sPattern,
                      boolean fIgnoreCase)

  Construct a LikeFilter for pattern match.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `sPattern` - the string pattern to compare the result with
    `fIgnoreCase` - true to be case-insensitive

### LikeFilter

    public LikeFilter(String sMethod,
                      String sPattern,
                      char chEscape,
                      boolean fIgnoreCase)

  Construct a LikeFilter for pattern match.
  Parameters:
    `sMethod` - the name of the method to invoke via reflection
    `sPattern` - the string pattern to compare the result with
    `chEscape` - the escape character for escaping '%' and '_'
    `fIgnoreCase` - true to be case-insensitive

### LikeFilter

    public LikeFilter(ValueExtractor extractor,
                      String sPattern,
                      char chEscape,
                      boolean fIgnoreCase)

  Construct a LikeFilter for pattern match.
  Parameters:
    `extractor` - the ValueExtractor to use by this filter
    `sPattern` - the string pattern to compare the result with
    `chEscape` - the escape character for escaping '%' and '_'
    `fIgnoreCase` - true to be case-insensitive

Method Detail

### evaluateExtracted

    protected boolean evaluateExtracted(Object oExtracted)

  Evaluate the specified extracted value.
  Specified by:
    `evaluateExtracted` in class `ExtractorFilter`
  Parameters:
    `oExtracted` - an extracted value to evaluate

### calculateEffectiveness

    public int calculateEffectiveness(Map mapIndexes,
                                      Set setKeys)

  Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be. <p/> The returned value is an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys. An operation that requires no more than a single access to the index content (i.e. Equals, NotEquals) has an effectiveness of one. Evaluation of a single entry is assumed to have an effectiveness that depends on the index implementation and is usually measured as a constant number of the single operations. This number is referred to as evaluation cost. <p/> If the effectiveness of a filter evaluates to a number larger than the `keySet.size() * <evaluation cost>` then a user could avoid using the index and iterate through the keySet calling `evaluate` rather then `applyIndex`.
  Specified by:
    `calculateEffectiveness` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the set of keys that will be filtered; read-only
  Returns:
    an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys

### applyIndex

    public Filter applyIndex(Map mapIndexes,
                             Set setKeys)

  Filter remaining keys using a Map of available indexes. <p/> The filter is responsible for removing all keys from the passed set of keys that the applicable indexes can prove should be filtered. If the filter does not fully evaluate the remaining keys using just the index information, it must return a filter (which may be an `EntryFilter`) that can complete the task using an iterating implementation. If, on the other hand, the filter does fully evaluate the remaining keys using just the index information, then it should return null to indicate that no further filtering is necessary.
  Specified by:
    `applyIndex` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the mutable set of keys that remain to be filtered
  Returns:
    a `Filter` object (which may be an `EntryFilter`) that can be used to process the remaining keys, or null if no additional filter processing is necessary

### getPattern

    public String getPattern()

  Obtain the filter's pattern string.
  Returns:
    the pattern string

### isIgnoreCase

    public boolean isIgnoreCase()

  Check whether or not the filter is case incensitive.
  Returns:
    true iff case insensitivity is specifically enabled

### getEscapeChar

    public char getEscapeChar()

  Obtain the escape character that is used for escaping '%' and '_' in the pattern or zero if there is no escape.
  Returns:
    the escape character

### showPlan

    public void showPlan()

  Display the execution plan that the LikeFilter has selected.

### readExternal

    public void readExternal(DataInput in)
                      throws IOException

  Restore the contents of this object by loading the object's state from the passed DataInput object.
  Specified by:
    `readExternal` in interface `ExternalizableLite`
  Overrides:
    `readExternal` in class `ComparisonFilter`
  Parameters:
    `in` - the DataInput stream to read data from in order to restore the state of this object
  Throws:
    `IOException` - if an I/O exception occurs
    `NotActiveException` - if the object is not in its initial state, and therefore cannot be deserialized into

### writeExternal

    public void writeExternal(DataOutput out)
                       throws IOException

  Save the contents of this object by storing the object's state into the passed DataOutput object.
  Specified by:
    `writeExternal` in interface `ExternalizableLite`
  Overrides:
    `writeExternal` in class `ComparisonFilter`
  Parameters:
    `out` - the DataOutput stream to write the state of this object to
  Throws:
    `IOException` - if an I/O exception occurs

### readExternal

    public void readExternal(PofReader in)
                      throws IOException

  Restore the contents of a user type instance by reading its state using the specified PofReader object.
  Specified by:
    `readExternal` in interface `PortableObject`
  Overrides:
    `readExternal` in class `ComparisonFilter`
  Parameters:
    `in` - the PofReader from which to read the object's state
  Throws:
    `IOException` - if an I/O error occurs

### writeExternal

    public void writeExternal(PofWriter out)
                       throws IOException

  Save the contents of a POF user type instance by writing its state using the specified PofWriter object.
  Specified by:
    `writeExternal` in interface `PortableObject`
  Overrides:
    `writeExternal` in class `ComparisonFilter`
  Parameters:
    `out` - the PofWriter to which to write the object's state
  Throws:
    `IOException` - if an I/O error occurs

### buildPlan

    protected void buildPlan()

  Build a plan for processing the LIKE functionality.

### isMatch

    protected boolean isMatch(String sValue)

  Check the passed String value to see if it matches the pattern that this filter was constructed with.
  Parameters:
    `sValue` - the String value to match against this filter's pattern
  Returns:
    true iff the passed String value is LIKE this filter's pattern

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.